<?php

namespace Drupal\geysir\Controller;

use Drupal\Core\Ajax\AjaxResponse;
use Drupal\Core\Ajax\OpenModalDialogCommand;
use Drupal\Core\Controller\ControllerBase;

/**
 * Controller for all modal dialogs.
 */
class GeysirModalController extends ControllerBase {

  /**
   * Create a modal dialog to edit a single paragraph.
   */
  public function edit($parent_entity_type, $parent_entity, $field, $field_wrapper_id, $delta, $paragraph, $js = 'nojs') {
    if ($js == 'ajax') {
      $options = [
        'dialogClass' => 'geysir-dialog',
        'width' => '60%',
      ];

      $response = new AjaxResponse();
      $form = $this->entityFormBuilder()->getForm($paragraph, 'geysir_modal_edit', []);
      $response->addCommand(new OpenModalDialogCommand($this->t('Edit paragraph'), render($form), $options));

      return $response;
    }

    return $this->t('Javascript is required for this functionality to work properly.');
  }

  /**
   * Create a modal dialog to delete a single paragraph.
   */
  public function delete($parent_entity_type, $parent_entity, $field, $field_wrapper_id, $delta, $paragraph, $js = 'nojs') {
    if ($js == 'ajax') {
      $options = [
        'dialogClass' => 'geysir-dialog',
        'width' => '20%',
      ];

      $form = $this->entityFormBuilder()->getForm($paragraph, 'geysir_modal_delete', []);

      $response = new AjaxResponse();
      $response->addCommand(new OpenModalDialogCommand($this->t('Delete paragraph'), render($form), $options));
      return $response;
    }

    return $this->t('Javascript is required for this functionality to work properly.');
  }

}
